// Задача "MP3-плеер"
// 4-я Интернет-олимпиада сезона 2009-2010, базовый уровень
// Автор задачи: Маским Носенко, nosenkomax@gmail.com
// Автор решения: Маским Носенко, nosenkomax@gmail.com
// Неверное решение - забываем про взятие по модулю с интами

import java.util.*;
import java.io.*;

public class mp3_mn_wrong1 implements Runnable {

	public static void main(String args[]) {
		new Thread(new mp3_mn_wrong1()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	private String FNAME = "mp3";
	boolean eof = false;

	@Override
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			br.close();
			out.close();

		} catch (Exception e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void My_Assert(boolean b, String s) {
		if (!b)
			throw new Error("Assertion " + s);
	}

	final int NMAX = 5000;
	final int MMAX = (int) 1e9;

	private void solve() {
		int n = nextInt();
		int m = nextInt();
		My_Assert(2 <= n && n <= NMAX, "n is out of range: " + n);
		My_Assert(2 <= m && m <= MMAX, "m is out of range: " + m);

		int[] t = new int[n], d = new int[n];

		d[0] = 1;
		for (int it = 2; it <= n; it++) {
			for (int i = 0; i < n; i++) {
				int ans = 0;
				if (i > 0)
					ans += d[i - 1];
				if (i < n - 1)
					ans += (i + 1) * d[i + 1];
				ans += d[i] * (it - 1 - i);
				t[i] = ans;
			}
			for (int i = 0; i < n; i++)
				d[i] = t[i];
		}
		out.println(d[0] % m);
	}
}